<?php /* /momo/index.php, (c) 2008, Andreas Forstinger, www.mobilemoodle.org */

/// basic setup

    // start output buffering to catch eventual outputs by old legacy code
    ob_start();

    // includes
    require ('../config.php'); 		// sets up db connection, session etc.
    require ('lib/lib.php');  		// load momo libraries

    global $SESSION, $CFG, $COURSE, $USER;

/// basic checks

    // check if client is MOMO
    if(!momo_basic_isMobileUser()){
        // print notice and redirect user to moodle index page
        ob_end_clean();
        redirect($CFG->wwwroot,momo_get_string('error_nonmobile'),'15');
        exit;
    }

    // check if MOMO is enabled in settings
    if(empty($CFG->momo_enabled)){
        // MOMO is disabled, print error screen
        if(momo_in_debug_mode()){
            momo_log('failed - momo disabled');
        }
        momo_print_error('error_momo_disabled');
        exit;
    }

    // check if Moodle site is in maintenance mode
    if (file_exists($CFG->dataroot . '/' . SITEID . '/maintenance.html')) {
        if(momo_in_debug_mode()){
            momo_log('failed - maintenance mode');
        }
        momo_print_error('error_maintenance');
        exit;
    }

/// session handling

    momo_login();
    
    // clear buffer because some auth plugins
    // and moodle core scripts might echo data
    ob_clean();
    
// check for parameters and serve the request
    $xmlRequest = optional_param($CFG->momo_mle_param_xml, null,PARAM_RAW);
    $contentRequest = optional_param($CFG->momo_mle_param_content, null,PARAM_RAW);
    $binRequest = optional_param($CFG->momo_mle_param_binary, null, PARAM_RAW);


	//checking if there are new msgs and if we should display the inbox symbol
	if(count_records('message', 'useridto', $USER->id)>0)
	{
		global $_COOKIE;
		// check if we are on a msg page
		$ismsgpage=($xmlRequest!=null&&strpos($xmlRequest,"msg/")!==false&&strpos($xmlRequest,"msg/")==0);
		
		if(empty($_COOKIE["msgsymbolaktiv"]))
		{// session doesn't work here ???
		// so lets use a cookie to store this information
		   $_COOKIE["msgsymbolaktiv"]=0;
			setcookie("msgsymbolaktiv", 0); 
		}
		if($xmlRequest!=null&&$ismsgpage)// we are currently on a msg page
			$_COOKIE["msgsymbolaktiv"]=0;// next time we view a normal page, we show the inbox symbol
		if(!$ismsgpage&&$_COOKIE["msgsymbolaktiv"]==0)
		{// if we are in the inbox, we don't show the message
		// if we have already send a msg, we don't need to send another one 
		    include_once("lib/lib_push.php");
		    momo_sendNewMessageNotification($USER->id);
		    $_COOKIE["msgsymbolaktiv"]=1;
		}
		setcookie("msgsymbolaktiv", $_COOKIE["msgsymbolaktiv"]); 
	}
	

/// serve request
	    
    if (!empty ($xmlRequest) || empty ($contentRequest) && empty ($binRequest)) {
        // a page is requested
        momo_handle_request_xml($xmlRequest);
    }
    else if ($contentRequest != null) {
        // content is requested
        momo_handle_request_content($contentRequest);
    }
    else if ($binRequest != null) {
        // a binary is requested
        momo_handle_request_binary($binRequest);
    }
?>
