<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $USER, $CFG;
require_once($CFG->dirroot . '/blog/lib.php'); // additional blog functions

// get user parameter
$userid = optional_param('user',null,PARAM_INT); // if not given use $USER
    if($userid == $USER->id || empty($userid)){
        $user = $USER;
        $myblog = true;
    }
    else{
        $user = get_record('user','id',$userid);
        $myblog = false;
    }

// get optional action parameter
$action = optional_param('action',null,PARAM_ALPHA); // "save", "update", "delete"

// react according to action parameter
if($action == 'save'){ // there is an entry to be stored
    // (see /blog/edit.php)
    $form = (object)$_POST;

    $blogEntry = new object;
    $blogEntry->subject = addslashes($form->subject);
    $blogEntry->summary = addslashes($form->message);
    $blogEntry->module = 'blog';
    $blogEntry->userid = $user->id;
    $blogEntry->format = FORMAT_PLAIN;
    $blogEntry->publishstate = $form->publish;
    $blogEntry->lastmodified = time();
    $blogEntry->created = time();

    // Insert the new blog entry.
    $entryID = insert_record('post',$blogEntry);

    if ($entryID) {
        // for some reason create a unique hash for this entry
        $dataobject = new object;
        $dataobject = md5($blogEntry->userid.$CFG->wwwroot.$entryID);
        $blogEntry->uniquehash = $dataobject;
        update_record('post', $blogEntry);

        /// Associate tags with entries
        $tag = NULL;
        $tag->entryid = $entryID;
        $tag->userid = $user->id;
        $tag->timemodified = time();

        /// Add tags information
        $possibletags = get_records('tags');

        // now check which of the tags were actually selected
        foreach($possibletags as $possible){
            $temp = optional_param($possible->id,0,PARAM_INT);
            if(!empty($temp)){ // if this tag was selected "1" is returned
                // add this tag as instance
                $tag->tagid = $possible->id;
                insert_record('blog_tag_instance',$tag);
           }
        }

        //record a log message of this entry addition
        if ($site = get_site()) {
            add_to_log($site->id, 'blog', 'add', 'index.php?userid='. $blogEntry->userid .'&postid='. $entryID, $blogEntry->subject);
        }

        momo_print_success(momo_get_string('msg_blog_entry_added'),'blog/blog.php', $CFG->momo_mle_server_link);
    }
    else{
         momo_print_error(momo_get_string('msg_blog_entry_failed'),'blog/blog.php', $CFG->momo_mle_server_link);
    }
}
else if ($action == 'update'){ // an entry has to be updated
    // get entry
    $id = optional_param('entry',null,PARAM_INT);
    $entry = get_record('post','id',$id);

    // check if user is allowed to update
    if(blog_user_can_edit_post($entry)){
        // update entry
        // (see /blog/edit.php)
        $form = (object)$_POST;

        $entry->subject = addslashes($form->subject);
        $entry->summary = addslashes($form->message);
        $entry->format = FORMAT_PLAIN;
        $entry->publishstate = $form->publish;
        $entry->lastmodified = time();

        if(update_record('post',$entry)){
            // also update tags (remove all tags first and add them again)
            delete_records('blog_tag_instance', 'entryid', $entry->id);

            $tag = NULL;
            $tag->entryid = $entry->id;
            $tag->userid = $user->id;
            $tag->timemodified = time();

            /// Add tags information
            $possibletags = get_records('tags');
            // now check which of the tags were actually selected
            foreach($possibletags as $possible){
                $temp = optional_param($possible->id,0,PARAM_INT);
                if(!empty($temp)){ // if this tag was selected "1" is returned
                    // add this tag as instance
                    $tag->tagid = $possible->id;
                    insert_record('blog_tag_instance',$tag);
               }
            }

            //record a log message of this entry update action
            if ($site = get_site()) {
                add_to_log($site->id, 'blog', 'update', 'index.php?userid='. $entry->userid .'&postid='. $entry->id, $entry->subject);
            }
         momo_print_success(momo_get_string('msg_blog_entry_updated'),'blog.php', $CFG->momo_mle_server_link);
        }
         else{
             momo_print_error(momo_get_string('msg_blog_entry_failed'),'blog.php', $CFG->momo_mle_server_link);
        }
    }
    else{
        momo_print_error(momo_get_string('msg_blog_edit_notallowed'),'blog.php', $CFG->momo_mle_server_link);
    }
}
else if ($action == 'delete'){
    // get entry to delete
    $id = optional_param('entry',null,PARAM_INT);
    $entry = get_record('post','id',$id);

    // be sure user is allowed to delete
    if (blog_user_can_edit_post($entry)) {
        if (delete_records('post','id',$entry->id)) {
            delete_records('blog_tag_instance', 'entryid', $entry->id);

            //record a log message of this entry deletion
            if ($site = get_site()) {
                add_to_log($site->id, 'blog', 'delete', 'index.php?userid='. $entry->userid, 'deleted blog entry with entry id# '. $entry->id);
            }
        }
     momo_print_success(momo_get_string('msg_blog_entry_deleted'),'blog.php', $CFG->momo_mle_server_link);
    }
    else{
           momo_print_error(momo_get_string('msg_blog_edit_notallowed'),'blog.php', $CFG->momo_mle_server_link);

    }
}

/// output
// get latest 3 entries
$entries = get_records_select('post','userid = ' . $user->id . ' and module = "blog"','lastmodified DESC','*','0','3');

if($entries){
    // get number of all entries
    $numEntries = count_records_select('post','userid = ' . $user->id . ' and module = "blog"');
}

?>
<ps t="<?php momo_print_string('hd_blog')?>" s="false" bo="true" back="<?php echo(momo_get_back_url())?>">
<pa>
<?php momo_print_header(momo_get_string('hd_blog'), 'blog') ?>
<font class="h2" /><?php momo_print_string('lbl_blog_latest')?><font class="std"/><br/>
<?php
    // print latest entries
    if($entries){
    foreach($entries as $entry){ ?>
<link type="<?php echo($CFG->momo_mle_server_link) ?>" url="blog/blog_entry.php&amp;id=<?php echo($entry->id) ?>" dt="l" di="<?php momo_print_icon_path('pst_posting') ?>" /> <?php echo($entry->subject)?><br/>
<?php } } ?>
<hr/>
<?php
    if(!empty($entries)){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="blog/blog_entries.php&amp;user=<?php echo($user->id)?>" dt="l" di"<?php momo_print_icon_path('pst_postings') ?>" word="<?php momo_print_string('lbl_blog_all')?> (<?php echo($numEntries)?>) " />
<?php
    }
    if($myblog){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="blog/blog_entry.php" dt="l" di="<?php momo_print_icon_path('pst_posting_new') ?>" word="<?php momo_print_string('lbl_blog_add')?>" />
<?php } ?>
</pa>
</ps>