<?php 
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get forum id
$id = optional_param('id',0,PARAM_INT);

// get forum
if(!$forum = get_record('forum', 'id', $id)){
    momo_print_error('error_parameter');
}

/// handle authentication
momo_login_to_course($forum->course);

// get course module
$cm = get_coursemodule_from_instance('forum', $forum->id, $forum->course);

// add log message, needed for reports and statistics
    if ($cm->id) {
        add_to_log($forum->course, 'forum', 'view forum', "view.php?id=$cm->id", "$forum->id", $cm->id);
    } else {
        add_to_log($forum->course, 'forum', 'view forum', "view.php?f=$forum->id", "$forum->id");
    }

$view_allowed = true;

$groups=array();
$groups=get_records_select('groups_members','userid='.$USER->id);
$groupList="";
if(!empty($groups))
{
    foreach($groups as $group)
    {
        $groupList.=",".$group->groupid;
    }
}
//momo_log($groupList,$action='forum debug',$url='');

/// get discussions
$discussions = array();

// in a 'single' type forum, only one discussion is allowed
if ($forum->type == 'single') {
    $discussions = get_records_select('forum_discussions','forum='.$forum->id.' AND groupid in (-1,0'.$groupList.')','timemodified DESC');
}
else{
    // get all discussions
    $discussions = get_records_select('forum_discussions','forum='.$forum->id.' AND groupid in (-1,0'.$groupList.')','timemodified DESC');
}

?>
<ps t="<?php momo_print_string('hd_forum')?>" s="false" bo="true" back="<?php echo(momo_get_back_url($COURSE->id))?>">
<pa>
<?php momo_print_header(momo_get_string('lbl_forum_discussions_all'), 'mod_forum') ?>
<font class="h2" /><?php momo_print_string('lbl_forum_discussions_all')?><font class="std"/><br/>
<?php
    // show discussions, use paging
    $wrap = $CFG->momo_wrap_limit;
    $count = 1;
    foreach($discussions as $discussion){
        if($count > $wrap){ // wrap content
            $count = 1;
            momo_print_paging();
        }
        // hack: get username for each discussion
        $username = get_field('user', 'username', 'id', $discussion->userid);
        ?>
<link type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_discussion.php&amp;id=<?php echo($discussion->id)?>" di="<?php momo_print_icon_path('pst_discussion') ?>" dt="l" /> <?php p(momo_truncate($discussion->name)) ?><br/>
<font style="i"/><?php $date = usergetdate($discussion->timemodified);
    echo(momo_truncate($username,10) . ', '. $date['mday'].'.'.$date['mon'].'.'.$date['year'].', '.$date['hours'].':'.$date['minutes']);?><font style="p"/><br/>
<?php
           $count++;
        }
?>
<hr/>
<?php // check if user is allowed to start new discussions and if so, print link
if(forum_user_can_post_discussion($forum)){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_discussion_new.php&amp;forum=<?php echo($forum->id) ?>" dt="l" di="<?php momo_print_icon_path('pst_discussion_new')?>" word="<?php momo_print_string('lbl_forum_discussion_new')?>"/>
<?php } ?>
</pa>
</ps>