<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get discussion id from request
$discussionid = optional_param('discussion',0,PARAM_INT);

// get discussion
if(!$discussion = get_record('forum_discussions','id',$discussionid)){
    momo_print_error('error_parameter');
}

// get forum
if(!$forum = get_record('forum','id',$discussion->forum)){
    momo_print_error('error_parameter');
}

/// handle authentication
momo_login_to_course($forum->course);

//get  initial posting
$initial = forum_get_firstpost_from_discussion($discussion->id);
$user = get_record('user','id',$initial->userid);

/// check for attachement
$attachment = false;
    if(!empty($initial->attachment)){
        $attachment = true;
        // get url to file
        $filearea = forum_file_area_name($initial);
        if ($CFG->slasharguments) {
             $ffurl = $CFG->wwwroot . '/file.php' . '/' . $forum->course . $filearea . '/' .$initial->attachment;
         }
         else {
             $ffurl = $CFG->wwwroot. '/file.php?file=' . '/' .$forum->course .$filearea . '/' .$initial->attachment;
         }
         // create also a specific MOMO compatible file request
         $internalurl = momo_get_binary_file_url($forum->course . $filearea . '/' .$initial->attachment);

        /// check type using regex
        $type = mimeinfo('type',$initial->attachment);
        $imagepattern = '/\.(jpg|jpeg|jpe|png)$/';
        $audiopattern = '/^audio/';
        $videopattern = '/^video/';
        // check if we have an image (only png and jpg are supported)
        if (preg_match($imagepattern, $initial->attachment)) {
            $link = '<image type="r" url="' . $ffurl . '">';
        }
        // check if we have audio 'audio/'
        else if (preg_match($audiopattern, $type)) {
            $link = '<audio location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $internalurl . '">';
        }
        // check if we have video 'video/'
        else if (preg_match($videopattern, $type)) {
            $link = '<video location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $internalurl . '">';
        }
        // the file can not be processed internally, give browser link
        else{
            $link = '<link type="p" dt="l" di="' . momo_get_icon_path('internet') . '" url="' . $ffurl . '">';
        }

}

// get replies
$posts = get_records_select('forum_posts',"discussion = $discussion->id and id <> $initial->id",'created DESC');

?>
<ps t="<?php momo_print_string('hd_forum_discussion')?>" s="false" bo="false" back="<?php echo(momo_get_back_url($COURSE->id))?>">
<pa>
<image type="l" url="<?php momo_print_icon_path('pst_discussion') ?>" /><font class="h1"/> <?php p(momo_truncate($discussion->name))?><font class="std"/>
<br/><hr/>
<font class="h2" /><?php momo_print_string('lbl_forum_discussion_initial')?><font class="std"/><br/>
<?php p('"'.$initial->message.'"')?><br/>
<?php if($attachment){
    echo($link . '</br>');
    echo(momo_truncate($post->attachment) . '</br>');
}
?>
<font style="i"/>
<?php $date = usergetdate($initial->created);
 echo($user->firstname . ' ' . $user->lastname . '<br/>'.$date['mday'].'.'.$date['mon'].'.'.$date['year'].', '.$date['hours'].':'.$date['minutes'].' '.'<br/>');
?>
<font style="p"/><hr/>
<font class="h2" /><?php momo_print_string('lbl_forum_replies')?><font class="std"/><br/>
<?php
    if(!empty($posts)){
    // print posts
    $wrap = $CFG->momo_wrap_limit;
    $count = 1;
    foreach($posts as $post){
        if($count > $wrap){ // wrap content
            $count = 1;
            momo_print_paging();
        }
        // hack: get username for each post
        $username = get_field('user', 'username', 'id', $post->userid);
        ?>
<link type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_post.php&amp;id=<?php echo($post->id)?>" di="<?php momo_print_icon_path('pst_posting') ?>" dt="l" /> <?php p(momo_truncate($post->subject)) ?> <br/>
<font style="i"/><?php $date = usergetdate($post->modified);
    echo(momo_truncate($username,10) . ', '. $date['mday'].'.'.$date['mon'].'.'.$date['year'].', '.$date['hours'].':'.$date['minutes']);?><font style="p"/><br/>
<?php
    $count++;}} ?>
<hr/>
<?php
    // check if the current user is allowed to post message, if so print link
    if(forum_user_can_post($forum,$USER)){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_post_new.php&amp;discussion=<?php echo($discussion->id)?>&amp;parent=<?php echo($initial->id)?>" dt="l" di="<?php momo_print_icon_path('pst_posting_new')?>" word="<?php momo_print_string('lbl_forum_post_new')?>"/>
<?php } ?>
</page>
</pagesuite>