<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER;
require ($CFG->dirroot . '/message/lib.php'); // messaging support
@ ob_clean(); // there migth be output from lib

// check for parameters
$message = optional_param('message',null,PARAM_RAW);
$rcpt = optional_param('rcpt',null,PARAM_INTEGER);

$success = true;
$errormsg = null;
$recipient = null;
if(!empty($message) && !empty($rcpt)){ // parameters are set (reply to a message)
    $recipient = get_record('user', 'id', $rcpt);
     // Check if the user is blocking us
    if ($contact = get_record('message_contacts', 'userid', $recipient->id, 'contactid', $USER->id)) {
        
        if ($contact->blocked and !isadmin()) {
            $success = false;
            $errormsg = 'msg_messaging_msg_blocked';
        }
    }
    if (get_user_preferences('message_blocknoncontacts', 0, $recipient->id)) {  // Recipient blocks users not on his contact list
        if (empty($contact)) {   // current user is not on recipients contact list
            $success = false;
            $errormsg = 'msg_messaging_msg_blocked_non_contact';
        }
    }
    if($success){
        // fire message in moodle (will be relayed in DB or even mailed if configured)
        $success = message_post_message($USER,$recipient,$message,FORMAT_PLAIN,'direct');
        add_to_log(SITEID, 'message', 'write', 'history.php?user1='.$recipient->id.'&amp;user2='.$USER->id.'#m'.$success, $recipient->id);

        // clean output buffer as there might be debug output (SMTP)
        @ ob_clean();
        // additionally push a notify to other user in case he is also online via momo
        require_once ($CFG->dirroot . '/momo/lib/lib_push.php');
        momo_sendNewMessageNotification($recipient->id,true);
        // log event
        momo_log('msg ' . $success . ' to ' . $rcpt ,'message sent');
        // print success screen
        momo_print_success(momo_get_string('msg_messaging_msg_sent',$recipient->username),'msg/messages.php', $CFG->momo_mle_server_link);
    }
    else{
        // log event
        momo_log('send failed to ' . $rcpt ,'message error');
        // print failure screen
        momo_print_error(momo_get_string('msg_messaging_msg_failed'), 'msg/messages.php', $CFG->momo_mle_server_link);
    }
}
else{
     momo_print_error('error_parameter');
}
?>