<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/resource/lib.php');
require_once($CFG->libdir.'/filelib.php');

// get resource id
$id = optional_param('id',0,PARAM_INT);

// get resource object
if(!$resource = get_record('resource', 'id', $id)){
    momo_print_error('error_parameter');
}

// handle authentication
momo_login_to_course($resource->course);

// add log entry
$cm = get_coursemodule_from_instance('resource',$resource->id,$COURSE->id);
add_to_log($COURSE->id, 'resource', 'view', "view.php?id={$cm->id}", $resource->id, $cm->id);

// check back url
$referer=momo_basic_get_header(MLIBERA_REFERER,null);

echo($referer);

/// output
?>
<ps t="<?php momo_print_string('hd_resource') ?>" s="false" bo="true" back="<?php echo momo_get_back_url($COURSE->id)?>">
<pa>
<?php momo_print_header($resource->name, 'mod_resource') ?>
<?php // print information common to all types ?>
<font class="h3"/><?php momo_print_string('lbl_resource_name')?><br/>
<font class="std"/><?php momo_print_converted_text($resource->name)?><br/>
<?php if(!empty($resource->summary)){ ?>
<font class="h3"/><?php momo_print_string('lbl_resource_summary')?><br/>
<font class="std"/><?php momo_print_converted_text($resource->summary)?>
<?php } ?>
<?php // view depends on type

switch ($resource->type) {

    // handle resource type "file"
    case 'file':
        // firstly, check if reference is an URL
        $link = '';
        $savelink = '';
        $isURL = false; // set default
        if(resource_is_url($resource->reference)){
            $isURL = true;
        }

        // declare some defaults
        $imagepattern = '/\.(jpg|jpeg|jpe|png)$/'; // only png and jpg supported
        $audiopattern = '/^audio/'; // match all mime types of form 'audio/xxx'
        $videopattern = '/^video/'; // match all mime types of form 'video/xxx'

        // get mime type of reference
        $type = strtolower(mimeinfo('type',$resource->reference));

        // check if resource is an IMAGE (only png and jpg are supported)
        if (preg_match($imagepattern, strtolower($resource->reference))) {
            // prepare link, either pointing to external image or internal one
            if ($isURL) { // URL reference
                $link = '<image type="r" url="' . momo_encode_login_information($resource->reference) . '">';
                $savelink = '<savefile type="h" url="' . momo_encode_login_information($resource->reference) . '" w="'. momo_get_string('lbl_resource_store') .'" full="false" />';
            }
            else { // reference points to relative file path on server
                $linkurl = momo_get_binary_file_url($resource->course . '/' . $resource->reference);
                $link = '<image type="r" url="' . $linkurl . '">';
                $savelink = '<savefile type="m" url="' . $linkurl . '" w="'. momo_get_string('lbl_resource_store') . '" w="'. momo_get_string('lbl_resource_store') .'" full="false"/>';
            }
        }

        // check if resource is an AUDIO file
        else if (preg_match($audiopattern, $type)) {
             // prepare link, either pointing to external or internal file
            if ($isURL) { // URL reference
                $link = '<audio location="h" contenttype="' . $type . '" url="' . momo_encode_login_information($resource->reference) . '">';
                $savelink = '<savefile type="h" url="' . momo_encode_login_information($resource->reference) . '" w="'. momo_get_string('lbl_resource_store') .'" full="false"/>';

            }
            else { // reference points to relative file path on server
                $linkurl = momo_get_binary_file_url($resource->course . '/' . $resource->reference);
                $link = '<audio location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $linkurl . '">';
                $savelink = '<savefile type="m" url="' . $linkurl . '" w="'. momo_get_string('lbl_resource_store') .'" full="false"/>';
            }
        }

        // check if resource is a VIDEO file
        else if (preg_match($videopattern, $type)) {
             // prepare link, either pointing to external or internal file
            if ($isURL) { // URL reference
                $link = '<video location="h" contenttype="' . $type . '" url="' . momo_encode_login_information($resource->reference) . '">';
                $savelink = '<savefile type="h" url="' . momo_encode_login_information($resource->reference) . '" w="'. momo_get_string('lbl_resource_store') .'" full="false"/>';
            }
            else { // reference points to relative file path on server
                $linkurl = momo_get_binary_file_url($resource->course . '/' . $resource->reference);
                $link = '<video location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $linkurl . '">';
                $savelink = '<savefile type="m" url="' .$linkurl . '" w="'. momo_get_string('lbl_resource_store') .'" full="false"/>';
            }
        }

        // handle any other case
        else {
             // prepare link, either pointing to external or internal file
            if ($isURL) { // URL reference
                $link = '<menu type="p" dt="l" di="' . momo_get_icon_path('internet') . '" full="false" word="' . momo_get_string('lbl_resource_open'). '" url="' . momo_encode_login_information($resource->reference) . '" />';
            }
            else { // reference points to relative file path on server
                // create URL including login information
                if ($CFG->slasharguments) {
                    $linkurl = $CFG->wwwroot . '/file.php' . '/' . $COURSE->id . '/' . $resource->reference;
                 }
                 else {
                    $linkurl = $CFG->wwwroot. '/file.php?file=' . '/' .$COURSE->id . '/' . $resource->reference;
                }
                $link = '<menu type="p" dt="l" di="' . momo_get_icon_path('internet') . '" full="false" word="' . momo_get_string('lbl_resource_open'). '" url="' . momo_encode_login_information($linkurl) . '" />';
            }
        }

        // show output
        ?>
<br align="center" />
<?php echo(momo_truncate(strtolower($resource->reference)))?><br/>
<?php echo($link)?><br/>
<?php echo($savelink)?><br/>
<?php
        break; // finished type "file"

    // handle resource type "text"
    case 'text':
        // show output
        ?>
<br/>
<font class="h3"/><?php momo_print_string('lbl_resource_content')?><br/>
<font class="std"/><?php momo_print_converted_text($resource->alltext)?><br/>
<?php
        break;

    // handle resource type "html"
    case 'html':
        // show output
        ?>
<br/>
<font class="h3"/><?php momo_print_string('lbl_resource_content')?><br/>
<font class="std"/><?php momo_print_converted_text($resource->alltext)?><br/>
<?php
        break;

    // handle unsupported resource types
    default:
        // show output
        ?>
<image type="l" url="<?php momo_print_icon_path('info')?>" /> <?php momo_print_string('msg_resource_type_unsupported')?>
<?php
        break;

} // end of switch (type)
?>

</page>
</pagesuite>