<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
// this page is called when MOMO decodes a semacode tag linking somewhere inside the Moodle site

global $CFG;

if(empty($CFG->semacode_supported)){ // just in case gps support is not installed
    momo_print_error('error_semacode_not_supported');
}

// get id of tag
$tagid = required_param('id', PARAM_INT);

if (!empty($tagid)) {
    // try to get semacode information
    if (!$semacode = get_record('semacode', 'id', $tagid)) {
       momo_print_error('error_parameter');
    }
}
else {
    momo_print_error('error_parameter');
    exit;
}

// act depending on semacode type

    $link = '';
    $message = 'error_semacode_outdated';
    $supported = true;

    switch ($semacode->type) {

        case 'u': // external url type
            $link = $semacode->url;
            $message = 'msg_semacode_url';
            break;

        case 'c': // course link type
            $link = momo_get_course_link($semacode->target);
            $message = 'msg_semacode_course';
            break;

        case 'a': // activity link type
            // get module information from course
            if($activity = get_record_sql("SELECT cm.id, cm.instance, m.name
                                            FROM {$CFG->prefix}course_modules cm,
                                             {$CFG->prefix}modules m
                                              WHERE cm.id = '$semacode->target' AND
                                              m.id = cm.module")) {

                $link = momo_get_activity_link($activity->name, $activity->id, true);
                if($link){
                    $message = 'msg_semacode_activity';
                }

            }
            break;

        case 'l': // location tag
            $link = momo_gps_get_locationbased_activities($semacode->latitude, $semacode->longitude, true);
            $message = 'msg_semacode_loc_activities';
            if(empty($link)){ //
                $link = '';
                $message = 'msg_semacode_loc_noactivities';
            }
            break;

        default:
            $message = 'msg_semacode_unknown'; // unknown type
            $supported = false;
            break;
    }

/// output
?>
<ps t"<?php momo_print_string('hd_semacode')?>" s="false" bo="false" ba="index.xml|y" >
<pa>
<?php momo_print_header(momo_get_string('hd_semacode'), 'mod_semacode') ?>
<?php
    if($supported){ // print message and link
        momo_print_string($message);
?>
<br a="center"/>
<?php echo($link); ?>
<?php }
    else{ // type not supported ?>
<image type="l" u="<?php momo_print_icon_path('info') ?>"/> <?php momo_print_string('msg_semacode_unknown') ?>
<?php } ?>
</pa>
</ps>